import { isString } from '@blackglory/prelude';
export class TextRange {
    constructor(startIndex, endIndex) {
        this.startIndex = startIndex;
        this.endIndex = endIndex;
    }
    toJSON() {
        return {
            startIndex: this.startIndex,
            endIndex: this.endIndex
        };
    }
    getStartIndex() {
        return this.startIndex;
    }
    getEndIndex() {
        return this.endIndex;
    }
    len() {
        return this.endIndex - this.startIndex;
    }
    extract(val) {
        const buffer = isString(val)
            ? Buffer.from(val, 'utf-8')
            : val;
        return buffer
            .slice(this.startIndex, this.endIndex)
            .toString('utf-8');
    }
}
//# sourceMappingURL=text-range.js.map